<?php
/**
 * Copyright since 2022 PayGreen
 * NOTICE OF LICENSE
 * This source file is subject to the MIT License X11
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to contact@paygreen.fr so we can send you a copy immediately.
 * @author    PayGreen <contact@paygreen.fr>
 * @copyright 2014 - 2022 Watt Is It
 * @license   https://opensource.org/licenses/mit-license.php MIT License X11
 */
if (!defined('_PS_VERSION_')) {
    exit;
}

class PaygreenPaymentFailureModuleFrontController extends ModuleFrontController
{
    /**
     * @return void
     * @throws PrestaShopException
     */
    public function postProcess()
    {
        $this->context->smarty->assign([
            'message' => $this->module->l('An error occurred. Please contact the merchant to have more information.'),
            'checkout_url' => $this->context->link->getPageLink('order', true, null, [
                'step' => 3,
            ]),
        ]);

        $this->setTemplate('module:' . $this->module->name . '/views/templates/front/error_17.tpl');
    }

    /**
     * @return bool
     */
    public function setMedia()
    {
        parent::setMedia();

        // @phpstan-ignore-next-line
        $this->context->controller->registerStylesheet(
            'error',
            'modules/' . $this->module->name . '/views/css/error.css',
            ['priority' => 150]
        );

        return true;
    }
}
