<?php
/**
 * Copyright since 2022 PayGreen
 * NOTICE OF LICENSE
 * This source file is subject to the MIT License X11
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to contact@paygreen.fr so we can send you a copy immediately.
 * @author    PayGreen <contact@paygreen.fr>
 * @copyright 2014 - 2022 Watt Is It
 * @license   https://opensource.org/licenses/mit-license.php MIT License X11
 */
if (!defined('_PS_VERSION_')) {
    exit;
}
function upgrade_module_0_1_3($module)
{
    $orderState = new OrderState();
    $orderState->send_email = false;
    $orderState->color = '#4169E1';
    $orderState->hidden = false;
    $orderState->delivery = false;
    $orderState->logable = false;
    $orderState->invoice = false;
    $orderState->module_name = 'paygreenpayment';

    $names = [];

    foreach (Language::getLanguages() as $language) {
        $iso = strtolower($language['iso_code']);
        $langId = $language['id_lang'];

        if ('fr' === $iso) {
            $names[$langId] = 'Paiement PayGreen initialisé';
        } else {
            $names[$langId] = 'Initialized PayGreen payment';
        }
    }

    $orderState->name = $names;

    if ($orderState->add()) {
        Configuration::updateValue('PAYGREEN_INITIALIZED_PAYMENT', (int) $orderState->id);

        return true;
    }

    return false;
}
